=== debian/changelog ===
ogre (1.7.4+dfsg1-7) unstable; urgency=low

  * Document some files oversought in debian/copyright (Closes: #690200).
    Thanks Bart Martens and Anton Gladky for reporting and collaborating in
    fixing the problem.
  * Patches:
    - Add remove-alignment.patch to drop obsolete stack alignment hack that
      breaks with gcc-4.7 (removed in upstream 1.8.1), and causes crashes on
      some architectures when using skeletons (possibly affecting a broad range
      of OGRE applications).  The patch is a modified version by me from the
      patch applied to 1.8.1, upstream does not support 1.7 series anymore.
      Thanks to Julian Taylor and Kai Mast for the report and point to upstream
      patch to 1.8 (#687013), and Nicolas Bourdaud for pointing to the problem
      in 1.7 series as well (Closes: #692397).

 -- Manuel A. Fernandez Montecelo <manuel.montezelo@gmail.com>  Tue, 13 Nov 2012 22:05:00 +0000

ogre (1.7.4+dfsg1-6) unstable; urgency=low

  * Remove Samples altogether, since almost all of them contain or depend on
    non-free items (fonts and some media objects, see Debian and upstream bug
    report).
    After contacting upstream, they are not inclined to resolve the issue soon
    (read: it will take years and several major releases, if it happens at all).
    All of them are removed and there will be no attempt to track which ones are
    DFSG-compliant; it is quite a burden (thus decreasing the time that can be
    devoted to maintain the package in good shape, follow closely upstream
    updates, etc), and this is even more complicated with different sets of
    samples in every release (as it is the case now, with v1.7 and v1.8 in the
    Debian archive).
    This change encompasses the following actions/changes:
    - Repack the source (simply removing all ./Samples/)
    - Remove patch change_sample_cfg_path.patch, of no use now
    - Remove corresponding sample packages from debian/control
    - Remove files debian/*samples*.install
    - Closes: #684218 ("ogre contains non-free font from larabie collection")
  * Force Build-Depends and Depends of libogre-dev on version 1.49 (this
    particular one since it is the default for Wheezy).  OGRE exposes internal
    source code from boost which is sometimes incompatible between versions and
    might produce deadlocks with applications using/linking incompatible
    versions of boost.  The problem is probably not fixed completely, but this
    is an attempt to mitigate it (see the bug report for the discussion).
    Thanks Paul D Turner for the toughtful report and Steve M. Robbins for
    feedback.  (Closes: #674633).

 -- Manuel A. Fernandez Montecelo <manuel.montezelo@gmail.com>  Wed, 10 Oct 2012 20:47:20 +0100

ogre (1.7.4-5) unstable; urgency=low

  * Modify options to avoid CPPFLAGS hardening flags missing (Closes: #665324)
  * Minor modifications to debian/copyright to avoid lintian warnings about
    non-conformant fields

 -- Manuel A. Fernandez Montecelo <manuel.montezelo@gmail.com>  Mon, 30 Apr 2012 17:26:58 +0100

ogre (1.7.4-4) unstable; urgency=low

  * Build-depends on libois-dev changed to [linux-any] only, and samples
    packages built for only for [linux-any] as well, since OIS does not build in
    non-Linux kernels/architectures (Closes: #664548).
  * Small reformat to debian/copyright to follow standards (a paragraph, content
    of a field, without a leading space)

 -- Manuel A. Fernandez Montecelo <manuel.montezelo@gmail.com>  Sun, 18 Mar 2012 22:01:08 +0000
